package com.huimv.acquisition.controller;



import java.util.Arrays;
import java.util.Map;
import com.huimv.acquisition.entity.CollectorGetIpRecordEntity;
import com.huimv.acquisition.result.R;
import com.huimv.acquisition.service.CollectorGetIpRecordService;
import com.huimv.acquisition.utils.PageUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;



/**
 * 
 *
 * @author chenshun
 * @email sunlightcs@gmail.com
 * @date 2022-03-16 11:09:58
 */
@RestController
@RequestMapping("generator/collectorgetiprecord")
public class CollectorGetIpRecordController {
    @Autowired
    private CollectorGetIpRecordService collectorGetIpRecordService;

    /**
     * 列表
     */
    @RequestMapping("/list")

    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = collectorGetIpRecordService.queryPage(params);

        return R.ok().put("page", page);
    }


    /**
     * 信息
     */
    @RequestMapping("/info/{id}")

    public R info(@PathVariable("id") Integer id){
		CollectorGetIpRecordEntity collectorGetIpRecord = collectorGetIpRecordService.getById(id);

        return R.ok().put("collectorGetIpRecord", collectorGetIpRecord);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")

    public R save(@RequestBody CollectorGetIpRecordEntity collectorGetIpRecord){
		collectorGetIpRecordService.save(collectorGetIpRecord);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")

    public R update(@RequestBody CollectorGetIpRecordEntity collectorGetIpRecord){
		collectorGetIpRecordService.updateById(collectorGetIpRecord);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		collectorGetIpRecordService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }

}
