 package com.huimv.acquisition.controller;

import com.baomidou.mybatisplus.core.InjectorResolver;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.huimv.acquisition.entity.CollectorRegisterEntity;
import com.huimv.acquisition.mapper.CollectorRegisterDao;
import com.huimv.acquisition.param.CollectorRegisterParam;
import com.huimv.acquisition.result.R;
import com.huimv.acquisition.service.CollectorRegisterService;
import com.huimv.acquisition.utils.PageUtils;
import com.huimv.core.pojo.response.ErrorResponseData;
import org.hibernate.mapping.Collection;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.view.script.ScriptTemplateConfig;

import javax.persistence.criteria.CriteriaBuilder;
import java.math.BigInteger;
import java.util.*;


 /**
 * 
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-07-30 09:45:22
 */
@RestController
@RequestMapping("management/collectorregister")
@CrossOrigin
public class CollectorRegisterController {
    @Autowired
    private CollectorRegisterService collectorRegisterService;

     @Autowired
     private CollectorRegisterDao  collectorRegisterDao ;

     //直接添加，不做校验  外部添加基站
     @RequestMapping("/addFromClient")
     public R addFromClient(@RequestBody Map<String, Object> params){
         //可以 全部收到
         List<String> deviceCodeList = (List<String>) params.get("deviceCodeList");  //耳基站号码  不止一个
         String penName = (String) params.get("penName");
         String unitName = (String) params.get("unitName");
         String farmName = (String) params.get("farmName");
         String farmId = (String) params.get("farmId");
         String serverIp = (String) params.get("serverIp");
         Integer stage = (Integer) params.get("stage");//上传的位置
         String registeCode = (String) params.get("registeCode");//机器编码
         Integer port = (Integer) params.get("port");//端口
         BigInteger orgId=new BigInteger((String) params.get("orgId"));
         String  orgName = (String) params.get("orgName");//组织名
         //不需要存栋舍的操作--不需要任何校验 直接操作
         System.out.println(registeCode);
         System.out.println(deviceCodeList);

         String[] registCode = registeCode.split(",");
         List<CollectorRegisterEntity>  co  = new ArrayList<>();
         //接受到了  执行存储
         //校验是否成功

         LambdaQueryWrapper<CollectorRegisterEntity> wrapper13 = Wrappers.lambdaQuery();
         wrapper13.in(CollectorRegisterEntity::getRegisteCode, registCode);
         List<CollectorRegisterEntity> collectorRegisters = collectorRegisterDao.selectList(wrapper13);
         System.out.println(collectorRegisters.size()+"长度");
         System.out.println(collectorRegisters);
         if (collectorRegisters.size() != 0) {
             List<String> devideCodes = new ArrayList<>();
             for (CollectorRegisterEntity collectorRegister : collectorRegisters) {
                 devideCodes.add(collectorRegister.getDeviceCode());
             }

             System.out.println( "添加失败，基站编码存在重复,重复编码为 " + devideCodes);
             return R.error().put("添加失败","添加失败，基站编码存在重复,重复编码为 " + devideCodes);
         }

         for (int i = 0; i < deviceCodeList.size(); i++) {
             CollectorRegisterEntity collectorRegisterEntity = new CollectorRegisterEntity();
             collectorRegisterEntity.setFarmCode(farmId);
             collectorRegisterEntity.setDeviceCode(deviceCodeList.get(i));
             collectorRegisterEntity.setRegisteCode(registCode[i]);  //放置芯片编码
             collectorRegisterEntity.setFarmName(farmName);//牧场ID
             collectorRegisterEntity.setStage(stage);//stage
             collectorRegisterEntity.setUnitName(unitName);//stage
             collectorRegisterEntity.setPenName(penName);//stage
             collectorRegisterEntity.setServerIp(serverIp);//stage
             collectorRegisterEntity.setOrgName(orgName);//stage
             collectorRegisterEntity.setPort(port);//port
             collectorRegisterEntity.setOrgId(orgId);//port
             collectorRegisterEntity.setRegisterTime(new Date());//s时间

            collectorRegisterService.save(collectorRegisterEntity);
         }
         return R.ok().put("sds",0);
     }

  //删除耳标同步到这里
  //直接添加，不做校验  外部添加基站
  @RequestMapping("/deleteFromClient")
  public R deleteFromClient(@RequestBody Map<String, Object> params) {
      //可以 全部收到---这儿传的设备编码 --已经确认不会重复了
      List<String> deviceCodeList = (List<String>) params.get("deviceCodeList");  //耳基站号码  不止一个

      LambdaQueryWrapper<CollectorRegisterEntity> wrapper13 = Wrappers.lambdaQuery();
      wrapper13.in(CollectorRegisterEntity::getRegisteCode, deviceCodeList);
      collectorRegisterDao.delete(wrapper13);
      return R.ok("删除成功").put("code", 10000);
  }




     /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestBody Map<String, Object> params){
        System.out.println(params.get("pageNo"));
        System.out.println(params.get("pageSize"));

        params.put("page",(String.valueOf(params.get("pageNo")))) ;
        params.put("limit",(String.valueOf(params.get("pageSize")))) ;
        PageUtils page = collectorRegisterService.queryPage(params);

        return R.ok().put("page", page).put("code",10000);
    }




    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		CollectorRegisterEntity collectorRegister = collectorRegisterService.getById(id);

        return R.ok().put("collectorRegister", collectorRegister);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody CollectorRegisterEntity collectorRegister){
		collectorRegisterService.save(collectorRegister);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody CollectorRegisterEntity collectorRegister){
		collectorRegisterService.updateById(collectorRegister);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		collectorRegisterService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }






}
