package com.huimv.acquisition.socket.eartagrecive.eartagsocket;

import io.netty.bootstrap.ServerBootstrap;
import io.netty.channel.ChannelFuture;
import io.netty.channel.ChannelInitializer;
import io.netty.channel.EventLoopGroup;
import io.netty.channel.nio.NioEventLoopGroup;
import io.netty.channel.socket.SocketChannel;
import io.netty.channel.socket.nio.NioServerSocketChannel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.io.*;
import java.net.Socket;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
//增加的功能----如果接受到86开头的基站芯片编码就直接断开（2G模块的需要主动断开）

@Component
public class EartagServer2 {
    @Autowired
    private EartagServerHandler2    serverHandler;
    //外面的版本    金华的端口     10024    10025  部署在31 服务器上面好了    10023是test1平台的
    //创建构造方法  瑞安 10024
    private int port = 10022;
    public EartagServer2(){
    }

   
/**
 *
 * 功能描述: 启动方法前台多个服务  处理多个线程
 *
 * @param:
 * @return:
 * @auther: LiGang
 * @date: 2019/3/26 11:31
 */
    /**
     * 启动流程
     */
    public void run() throws InterruptedException {
        //配置服务端线程组
        EventLoopGroup bossGroup=new NioEventLoopGroup();
        EventLoopGroup workGroup=new NioEventLoopGroup();

        try{
            //引导整个server的启动
            ServerBootstrap serverBootstrap = new ServerBootstrap();
            serverBootstrap.group(bossGroup,workGroup)
                    .channel(NioServerSocketChannel.class)    //指定处理的连接类型
                    .childHandler(new ChannelInitializer<SocketChannel>() {

                        @Override
                        protected void initChannel(SocketChannel socketChannel) throws Exception {
//                           socketChannel.pipeline().addLast(new EartagServerHandler2());
                            socketChannel.pipeline().addLast(serverHandler);
                        }
                    });

            System.out.println("Echo 服务器启动ing--监听端口"+port);
            //绑定端口，同步等待成功
            ChannelFuture cf = serverBootstrap.bind(port).sync();

            System.out.println("ok");
            // 等待服务端监听端口关闭
            cf.channel().closeFuture().sync();
        }finally {
            //优雅的退出
            bossGroup.shutdownGracefully();
            workGroup.shutdownGracefully();
        }
    }




    public static void main(String[] args) throws IOException {
        //建立socket向服务器发送连接请求
        Socket socket = new Socket("127.0.0.1", 10024);
        InputStream inputStream;
        inputStream = socket.getInputStream();
        OutputStream outputStream = socket.getOutputStream();
        //客户端向socket发送数据
        PrintWriter printWriter = new PrintWriter(outputStream);
        //printWriter.println("zj+202007239999893+133070303805451+86+0+2031+0+93+20211111153254+1.0#1.0#11600+0+end");    //没有注册
        //printWriter.println("hm+869401040126203+0+7+end");//没有注册
        //printWriter.println("zj+202007239999892+133070300000099+77+0+0+0+96+2021109916" + i +"33+1.0#1.0#9383+0+end");
        printWriter.println("2642 2642 2036 2143 2004 1846 2136 1620 1591 1949 1708 2039 1956 1398 1724 1376 1334 1843 1717 2162 1969 2191 1862 1865 1843 1540 1640 2175 1301 2407 1388 1572 2101 1295 2017 2230 2117 1985 2123 2130 1620 1949 1936 2007 1843 1914 1540 1998 1733 1240 1334 1595 1318 1749 1949 1901 2210 2078 2146 1943 1788 1807 1595 2117 1202 1388 2126 1176 2094 1285 1414 2091 1575 1824 1740 1604 1691 1650 2494 1666 1737 2452 2172 1556 2143 1363 1514 1650 1978 1401 2510 1959 2278 2400 1943 1324 1849 2101 1511 1485 1434 1956 1437 1766 1891 1962 1988 1550 2085 2039 2204 2010 1956 1714 2114 1659 1543 1701 2313 1743 2094 2130 2059 2207 1617 2713 1533 2043 1875 1530 1782 1314 2001 1646 1775 1675 1927 1769 2278 1898 1885 1392 1540 1927 2091 1920 2371 1911 2410 1894 1972 1727 2001 1240 2052 1347 1814 1878 1662 1933 2104 1766 2172 1885 2255 1862 1595 1827 1917 2175 1650 1701 2178 1952 1933 1988 1434 1508 1511 1788 1740 2445 2339 2172 2639 1714 1859 1849 1717 1733 1791 1981 2539 1827 2242 1749 1495 1914 1994 1472 1704 1846 1882 2033 1669 1724 1962 1266 2062 1669 1727 2310 1801 2462 1940 2155 2204 1679 2107 1366 1717 1308 1656 1601 1498 1724 1923 1904 1907 1985 2201 1936 1733 1798 1669 1446 2059 1650 2455 1878 1972 1769 1456 1840 2027 1923 1749 2220 1956 2323 2081 1708 2230 1569 1846 1682 1898 1911 2233 2091 1965 1801 1875 2056 1440 1753 1414 2017 2346 2052 2033 1427 2165 1572 1717 1585 1392 1173 2468 1591 2233 1708 1450 2510 1479 1836 1530 1891 2056 1869 2104 2130 1550 1704 1585 1640 1579 1527 1888 1585 1891 2217 1814 2097 2407 1640 1894 1475 1791 1798 1376 1575 1917 2027 1940 2075 1347 2162 1830 1949 1830 1633 2162 1936 2152 2133 1308 1430 1382 1662 1753 2246 1830 1836 1830 1898 1405 1824 1711 1643 2143 1956 1582 1434 2030 1575 2149 1788 1572 1817 1730 2036 1985 1740 1888 1888 1830 1737 1798 2294 2043 1521 1572 1759 1292 2059 1463 2068 1840 1727 2168 2130 1695 1859 1579 1553 1521 1814 2075 1962 2423 2027 1192 1862 1234 1701 1221 1756 1537 2120 2294 2133 1601 2181 2081 1965 2475 1443 1704 1595 1456 1711 1917 1830 1814 2036 2014 2175 2168 1882 1998 1820 2033 1521 2027 1846 1933 2184 1511 1836 1595 1727 1762 1611 1888 1788 1885 1646 2188 1798 1633 2281 1727 1627 2010 1853 1633 1459 1521 1311 1859 1650 1836 2059 2204 1943 1907 1917 1611 1614 1450 1891 1846 1540 1266 1965 1920 1994 1775 1856 1936 1701 1840 2126 1978 2068 1824 1679 1795 1762 1659 1585 1485 1894 1985 1604 2491 1453 1769 1801 1514 1691 1930 1759 1479 2220 1994 1691 1888 2043 1086 1305 1530 1453 1591 2155 1646 1969 2452 2004 2217 1869 1572 2126 1463 1627 1463 2052 2239 1762 1872 2091 1163 1946 1582 1198 1656 1614 1972 2259 2149 2094 1662 1401 1901 1424 1907 1330 1914 1981 2101 1717 1917 1743 1501 1566 1620 1517 1682 2242 1366 1620 1914 1140 1817 1533 1853 1704 2014 1824 2004 2049 1759 1579 2056 1772 1482 2027 2143 1911 2036 1495 1318 1227 1363 1962 1566 2104 1811 1679 2081 1495 1601 1256 1811 1685 2668 1965 1853 1769 1743 1640 150");
        printWriter.flush();
        //读取数据
        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream));
        String readLine = bufferedReader.readLine();
        System.out.println(readLine);
        inputStream.close();
        outputStream.close();
        socket.close();
    }
}
